/*! \file L2ProjectionBaseAnalysis.h 
 *  \brief: header file for generic external result object
 */

#ifndef _L2ProjectionBaseAnalysis_
#define _L2ProjectionBaseAnalysis_

/*Headers*/
#include "./Analysis.h"

class L2ProjectionBaseAnalysis: public Analysis{

	public:
		int  DofsPerNode(int** doflist,int meshtype,int approximation);
		void UpdateParameters(Parameters** pparameters,IoModel* iomodel,int solution_enum,int analysis_enum);
		void UpdateElements(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type);
		void CreateNodes(Nodes** pnodes,IoModel* iomodel);
		void CreateConstraints(Constraints** pconstraints,IoModel* iomodel);
		void CreateLoads(Loads** ploads, IoModel* iomodel);
};
#endif
